; balloon
; creates a balloon like in comics
; (C) Copyright 2000 by Michael Spunt <t0mcat@gmx.de>
;
; Updated to Gimp2.4 (11-2007) http://www.gimpscripts.com
; Updated to (05-20237) MareroQ: update for Gimp 2.10 , replace SF-VALUE to SF-ADJUSTMENT, added color selection boxes
 
; Line =FG fill=BG
(define (round-balloon img drawable bw bh rect np orientation revert lw)
(let* ((x 0))
(if (= np FALSE) (begin
(set! x (- (* bw 0.5) (* bw 0.2)))
(gimp-ellipse-select img x (* bh 0.5) (* bw 0.4) (* bh 0.4) CHANNEL-OP-REPLACE TRUE FALSE 0)
(set! x (- (* bw 0.5) (* bw 0.2) (* bw orientation -0.1)))
(gimp-ellipse-select img x (* bh 0.5) (* bw 0.4) (* bh 0.4) CHANNEL-OP-SUBTRACT TRUE FALSE 0)))
(if (= revert FALSE) (gimp-selection-translate img (* bw orientation 0.3) 0))
(if (= rect FALSE) (gimp-ellipse-select img (* bw 0.1) (* bh 0.1) (* bw 0.8) (* bh 0.65) CHANNEL-OP-ADD TRUE FALSE 0))
(if (= rect TRUE) (gimp-round-rect-select img (* bw 0.1) (* bh 0.1) (* bw 0.8) (* bh 0.65) 10 10 0 TRUE FALSE 0 0))
(gimp-edit-fill drawable 0)
(gimp-selection-shrink img lw)
(gimp-edit-fill drawable 1)))

(define (round-think-balloon img drawable bw bh rect np orientation revert lw)
(let* ((x 0))
(if (= np FALSE) (begin
(set! x (+ (* bw 0.5) (* bw -0.025) (* bw orientation 0.3)))
(gimp-ellipse-select img x (* bh 0.85) (* bw 0.05) (* bh 0.05) CHANNEL-OP-REPLACE TRUE FALSE 0)
(set! x (+ (* bw 0.5) (* bw -0.05) (* bw orientation 0.2)))
(gimp-ellipse-select img x (* bh 0.75) (* bw 0.1) (* bh 0.1) CHANNEL-OP-ADD TRUE FALSE 0)))
(if (= revert TRUE) (gimp-selection-translate img (* orientation bw -0.3) 0))
(if (= rect FALSE) (gimp-ellipse-select img (* bw 0.1) (* bh 0.1) (* bw 0.8) (* bh 0.65) CHANNEL-OP-ADD TRUE FALSE 0))
(if (= rect TRUE) (gimp-round-rect-select img (* bw 0.1) (* bh 0.1) (* bw 0.8) (* bh 0.625) 10 10 0 TRUE FALSE 0 0))
(gimp-edit-fill drawable 0)
(gimp-selection-shrink img lw)
(gimp-edit-fill drawable 1)))

(define (script-fu-balloon-new bw bh rect np think right revert lw bg-color fg-color)
(let* (
(orientation 1)
(side 1)
(img (car (gimp-image-new bw bh RGB)))
(balloon (car (gimp-layer-new img bw bh RGBA-IMAGE "Balloon" 100 LAYER-MODE-NORMAL-LEGACY))))
    (gimp-context-set-background bg-color)
	(gimp-context-set-foreground fg-color)
(if (= right FALSE) (set! orientation -1))

(gimp-image-add-layer img balloon 1)
(gimp-display-new img)
(gimp-edit-clear balloon)

(if (= think FALSE) (round-balloon img balloon bw bh rect np orientation revert lw))
(if (= think TRUE) (round-think-balloon img balloon bw bh rect np orientation revert lw))

(gimp-selection-none img)
(gimp-displays-flush)))

(script-fu-register
  "script-fu-balloon-new"
  "Bubbles for Comics..."
  "Creates a balloon like used in comics."
  "Michael Spunt"
  "Copyright 2000, Michael Spunt"
  "May 20, 2000"
  ""
  ;SF-VALUE "Width"		"240"
  SF-ADJUSTMENT "Width" '(240 20 1000 1 1 0 0)
  ;SF-VALUE "Height"		"160"
  SF-ADJUSTMENT "Height" '(160 20 1000 1 1 0 0)  
  SF-TOGGLE "Rectangle"		FALSE
  SF-TOGGLE "No pointer"	FALSE
  SF-TOGGLE "Think"		FALSE
  SF-TOGGLE "Right oriented"	FALSE
  SF-TOGGLE "Change side"	FALSE
  ;SF-VALUE "Line width"		"2"
  SF-ADJUSTMENT "Line width" '(2 1 100 1 1 0 0)
  SF-COLOR      _"Fill Color (BG)"   "white"
  SF-COLOR      _"Line Color (FG)"   "black"  
)
(script-fu-menu-register "script-fu-balloon-new"
                         "<Image>/Filters/Decor/Comics")